package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ims.eval.config.CustomException;
import com.ims.eval.entity.EvaluateReport;
import com.ims.eval.dao.EvaluateReportMapper;
import com.ims.eval.entity.Indicator;
import com.ims.eval.entity.OrganizationEvaluation;
import com.ims.eval.service.IEvaluateReportService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.eval.service.IOrganizationEvaluationRuleService;
import com.ims.eval.service.IOrganizationEvaluationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-03-25
 */
@Service
public class EvaluateReportServiceImpl extends ServiceImpl<EvaluateReportMapper, EvaluateReport> implements IEvaluateReportService {


	@Autowired
	private IOrganizationEvaluationService organizationEvaluationService;


	@Autowired
	private IOrganizationEvaluationRuleService organizationEvaluationRuleService;
	//考评结果报告
	//按照业务类型生成
	//业务阶综合展示

	@Override
	public boolean generateEvaluateReport(String organizationEvaluationId) {
		OrganizationEvaluation evaluation = organizationEvaluationService.getById(organizationEvaluationId);
		if (null == evaluation) {
			throw new CustomException("没有此靠考评");
		}

		//获取到对应组织考评规则
		String evaluationRuleIds = evaluation.getOrganizationEvaluationRuleId();
		if (null == evaluationRuleIds || evaluationRuleIds.length() <= 0) {
			throw new CustomException("组织考评id为空");
		}

		//
//		organizationEvaluationRuleService.listByIds();

		return false;
	}

	@Override
	public IPage<EvaluateReport> list(Integer pageNum, Integer pageSize, String id, String evaluateReportName, String binSection, String organizationEvaluationId, String organizationType, String checkCycle, String year, String month) {
		Page<Indicator> page = new Page<>(pageNum, pageSize);
		if (null == pageNum || null == pageSize) {
			throw new CustomException("分页参数为空");
		}
		IPage<EvaluateReport> list = null;
		try {
			list = baseMapper.selectListPage(page, id, evaluateReportName, binSection, organizationEvaluationId, organizationType, checkCycle, year, month);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return list;
	}
}
